#include "AsteroidsShip.h"

#include "core/CoreIncludes.h"
#include "core/XMLPort.h"
#include "Asteroids.h"
#include "graphics/Camera.h"
#include "asteroids/AsteroidStone.h"
#include "weapons/projectiles/Projectile.h"
#include "asteroids/AsteroidsCenterpoint.h"


namespace orxonox
{
    //Constructor
    RegisterClass(AsteroidsShip);

    AsteroidsShip::AsteroidsShip(Context* context) : SpaceShip(context)
    {
        RegisterObject(AsteroidsShip);

        direction= 0.0f;

        isFireing = false;
        damping = 0.90;

        lastTimeFront = 0;
        lastTimeLeft = 0;
        lastTime = 0;

        height = 600;
        width = 1000;
    }


    //update coordinates and velocity
    void AsteroidsShip::tick(float dt)
    {
        orxout() << "ich ticke!"<< endl;
        SUPER(AsteroidsShip, tick, dt);

        //Movement computation beachte Beschleunigung?
        Vector3 pos = getPosition();
        Vector3 vel = getVelocity();

        float speed = sqrt(vel.x*vel.x+ vel.z*velo.z);


        //Daempfung falls das spaceship zu schnell wird
        if(speed > maxspeed)
        {
            vel.x *= maxspeed/speed;
            vel.z *= mayspeed/speed;
        }

        if(moveUpPressed_)
        {
            //Gas geben
            vel.x += 1;
            vel.z += 1;

        }else if(moveDownPressed_){
            //Bremsen
            vel.x += 1;
            vel.z += 1;
        }else if(moveLeftPressed_){
            //rotate left
        }else if (moveRightPressed_){
            //rotateright
        }    

        setVelocity(vel);
        
        pos.x += vel.x*dt;
        pos.z += vel.z*dt;



        //haelt ship innerhalb des Kamerafensters, kommt oben bzw seitlich wieder raus. Man spawnt in (0,0)
        if(pos.x > width/2)   pos.x = -width/2;
        if(pos.x < -width/2)  pos.x = width/2;
        if(pos.z > height/2)  pos.z = -height/2;
        if(pos.z < -height/2) pos.z = height/2;


        //Schiessen wenn geschossen wurde
        // shoot!

        if (isFireing)
            ControllableEntity::fire(0);
    

        // bring back on track!
        if(pos.y != 0)
        {
            pos.y = 0;
        }

        //Reibung?
        vel.x *= damping;
        vel.y *= damping;


        setPosition(pos);
        setOrientation(Vector3::UNIT_Y, Degree(direction));

        // Reset key variables
        moveUpPressed_ = false;
        moveDownPressed_ = false;
        moveLeftPressed_ = false;
        moveDownPressed_ = false;


    }

    void AsteroidsShip::moveFrontBack(const Vector2& value)
    {
        if (value.x > 0)
        {
            moveUpPressed_ = true;
            moveDownPressed_ = false
            if(moveUpPressed_)
            {
                orxout() << "up" << endl;
            }
        }
        else
        {
            moveUpPressed_ = false;
            moveDownPressed_ = true;
            if(moveDownPressed_)
            {
                orxout() << "down" << endl;
            }
        }
    }

    void AsteroidsShip::moveRightLeft(const Vector2& value)
    {
        if (value.x > 0)
        {
            moveLeftPressed_ = false;
            moveRightPressed_ = true;
        }
            if(moveRightPressed_)
            {
                orxout() << "right" << endl;
            }

        else
        {
            moveLeftPressed_ = true;
            moveRightPressed_ = false;
            if(moveLeftPressed_)
            {
                orxout() << "left" << endl;
            }
        }
    }
    

    Asteroids* AsteroidsShip::getGame()
    {
        if (game == nullptr)
        {
            for (Asteroids* asteroids : ObjectList<Asteroids>())
                game = asteroids;
        }
        return game;
    }

    void AsteroidsShip::death()
    {
        getGame()->costLife();
        SpaceShip::death();
    }



}